unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, BcExpressions;

type
  TExpressionTestForm = class(TForm)
    Compile: TButton;
    Label1: TLabel;
    Label2: TLabel;
    BtnExecute: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Memo3: TMemo;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    Button3: TButton;
    Button4: TButton;
    Memo5: TMemo;
    Memo6: TMemo;
    Bevel1: TBevel;
    Bevel2: TBevel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    Label7: TLabel;
    Label8: TLabel;
    Button2: TButton;
    Button5: TButton;
    Label9: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Button6: TButton;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Label10: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Label11: TLabel;
    Edit2: TEdit;
    Label12: TLabel;
    Edit6: TEdit;
    Label13: TLabel;
    Edit7: TEdit;
    Label14: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CompileClick(Sender: TObject);
    procedure BtnExecuteClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Memo6Change(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
    Express: TBcExpressionCompiler;
    function GetTagValue(ATag: string; var AValue: string): Boolean;
  public
    { Public declarations }
  end;

var
  ExpressionTestForm: TExpressionTestForm;

implementation

{$R *.DFM}

procedure TExpressionTestForm.Timer1Timer(Sender: TObject);
begin
  Caption := IntToHex((GetWindowLong(GetForegroundWindow, GWL_STYLE) and WS_CAPTION), 8);
end;

procedure TExpressionTestForm.FormCreate(Sender: TObject);
begin
  Express := TBcExpressionCompiler.Create;
  Express.CodeSegment.DataSegment.OnTag := GetTagValue;
end;

procedure TExpressionTestForm.FormDestroy(Sender: TObject);
begin
  FreeAndNil(Express);
end;

procedure TExpressionTestForm.CompileClick(Sender: TObject);
var
  I: Integer;
  S: string;
begin
  try
    Express.CaseSensitive := CheckBox1.Checked;
    Express.RaiseErrors := CheckBox2.Checked;
    Express.TagBeginChar := Edit1.Text[1];
    Express.TagEndChar := Edit3.Text[1];
    Express.BlockBeginChar := Edit4.Text[1];
    Express.BlockEndChar := Edit5.Text[1];
    Express.BlockORChar := Edit2.Text[1];
    Express.EscapeChar := Edit7.Text[1];
    Express.BlockCmpChar := Edit6.Text[1];

    Express.Input := Memo6.Text;
    Express.Compile;

    ListBox3.Clear;
    for I := 0 to Express.CodeSegment.Count - 1 do
    begin
      S := '';
      case Express.CodeSegment[I]^.OPCode of
        OPNil: S := 'Nil';
        OPHalt: S := 'Halt';
        OPExit: S := 'Exit';
        OPConcat: S := 'Concat';
        OPJmp: S := 'Jmp';
        OPCmp: S := 'Cmp';
        OPClr: S := 'Clr';
      end;
      ListBox3.Items.Add(IntToStr(I) + ' -> OPCode: ' + S);
      ListBox3.Items.Add('  Param0: ' + IntToStr(Express.CodeSegment[I]^.Param0));
      ListBox3.Items.Add('  Param1: ' + IntToStr(Express.CodeSegment[I]^.Param1));
      ListBox3.Items.Add('  Param2: ' + IntToStr(Express.CodeSegment[I]^.Param2));
      ListBox3.Items.Add('  Param3: ' + IntToStr(Express.CodeSegment[I]^.Param3));
{      ListBox3.Items.Add('  Param4: ' + IntToStr(Express.CodeSegment[I]^.Param4));
      ListBox3.Items.Add('  Param5: ' + IntToStr(Express.CodeSegment[I]^.Param5));
      ListBox3.Items.Add('  Param6: ' + IntToStr(Express.CodeSegment[I]^.Param6));
      ListBox3.Items.Add('  Param7: ' + IntToStr(Express.CodeSegment[I]^.Param7));}
      ListBox3.Items.Add(StringOfChar('=', 25));
    end;
    ListBox3.Items.Add('eoc');
    Button3.Click;
    Button5.Enabled := True;
    Memo5.Text := '';
    BtnExecute.Enabled := True;
  finally
  end;
end;

procedure TExpressionTestForm.BtnExecuteClick(Sender: TObject);
begin
  Memo5.Text := '';
  Button4.Click;
  Express.CodeSegment.Execute;
  Button3.Click;
  Button1.Click;
  Memo5.Text := Express.CodeSegment.Output;
end;

function TExpressionTestForm.GetTagValue(ATag: string;
  var AValue: string): Boolean;
begin
  Result := Memo3.Lines.IndexOfName(LowerCase(ATag)) <> -1;
  if Result then
    AValue := Memo3.Lines.Values[LowerCase(ATag)];
end;

procedure TExpressionTestForm.Button1Click(Sender: TObject);
var
  I: Integer;
  S: string;
begin
  ListBox1.Clear;
  for I := 1 to Express.CodeSegment.DataSegment.RuntimeCount - 1 do
  begin
    S := IntToStr(I) + ': ';
    if Express.CodeSegment.DataSegment[-I]^.Reference >= -1 then
      S := S + 'TagRef('+ IntToStr(Express.CodeSegment.DataSegment[-I]^.Reference) + '): '
    else
      S := S + 'DataStr: ';
    S := S + '''' + Express.CodeSegment.DataSegment[-I]^.Value + '''';
    ListBox1.Items.Add(S);
  end;
end;

procedure TExpressionTestForm.Button3Click(Sender: TObject);
var
  I: Integer;
  S: string;
begin
  ListBox2.Clear;
  for I := 0 to Express.CodeSegment.DataSegment.Count - 1 do
  begin
    S := IntToStr(I) + ': ';
    if Express.CodeSegment.DataSegment[I]^.Reference >= -1 then
      S := S + 'TagRef('+ IntToStr(Express.CodeSegment.DataSegment[I]^.Reference) + '): '
    else
      S := S + 'DataStr: ';
    S := S + '''' + Express.CodeSegment.DataSegment[I]^.Value + '''';
    ListBox2.Items.Add(S);
  end;
end;

procedure TExpressionTestForm.Button4Click(Sender: TObject);
var I, Idx: Integer;
begin
  for I := 0 to Memo3.Lines.Count - 1 do
  begin
    if Express.CodeSegment.DataSegment.IndexOfTag(Memo3.Lines.Names[I], Idx) then
      Express.CodeSegment.DataSegment[Express.CodeSegment.DataSegment[Idx]^.Reference]^.Value :=
        Memo3.Lines.Values[Memo3.Lines.Names[I]];
  end;
  Button3.Click;
  
end;

procedure TExpressionTestForm.Button5Click(Sender: TObject);
begin
  Express.CodeSegment.RunPoint := 0; // start from first
  Express.CodeSegment.DataSegment.ClearResultValue;
  Button2.Enabled := True;
  Label9.Caption := 'Point: ' + IntToStr(Express.CodeSegment.RunPoint);
  ListBox3.ItemIndex := 0;
end;

procedure TExpressionTestForm.Button2Click(Sender: TObject);
begin
//  if Button2.Enabled then
  Button2.Enabled := Express.CodeSegment.ExecuteNext = 0;
  Button1.Click;
  Button3.Click;
  ListBox3.ItemIndex := Express.CodeSegment.RunPoint * 6 + 10;
  ListBox3.ItemIndex := Express.CodeSegment.RunPoint * 6;
  Label9.Caption := 'Point: ' + IntToStr(Express.CodeSegment.RunPoint);
//  if not Button2.Enabled then
    Memo5.Text := Express.CodeSegment.Output;
end;

procedure TExpressionTestForm.Memo6Change(Sender: TObject);
begin
  BtnExecute.Enabled := False;
  Button5.Enabled := False;
end;

procedure TExpressionTestForm.Button6Click(Sender: TObject);
begin
  Memo5.Text := '';
end;

end.
