{ Unit: BcWinShell
  ===========================================================================

  The contents of this file are subject to the Bluecave Public License V 1.1
  (the "License"). You may not copy or use this file, in either source code
  or executable form, except in compliance with the License. You may obtain
  a copy of the License at http://www.bluecave.net/licenses/.

  Software distributed under the License is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
  for the specific language governing rights and limitations under the
  License.

  Copyright (C) 2001-2002 Bluecave Software. All Rights Reserved.
  http://www.bluecave.net/

  Copyright (C) 2001-2002 Jouni Airaksinen. All Rights Reserved.
  http://Mintus.Codefield.com/ -- Mintus@Codefield.com

  ===========================================================================

  Unit description:

    Helper functions for Windows Shell, Registry, etc..

  History:

    2001-11-13: Initial version

  =========================================================================== }

{$I DFS.inc}
{$I BcDirectives.inc}

unit BcWinShell;

interface

uses Windows;

function WriteRun(LocalMachine: Boolean; Once: Boolean; Description, Command: string): Boolean;

implementation

function WriteRun(LocalMachine: Boolean; Once: Boolean; Description, Command: string): Boolean;
const
  RunOnceKey = 'Software\Microsoft\Windows\CurrentVersion\RunOnce';
  RunKey = 'Software\Microsoft\Windows\CurrentVersion\Run';
var
  RootKey: HKEY;
  Key: HKEY;
  SKey: string;
begin
  if LocalMachine then
    RootKey := HKEY_LOCAL_MACHINE
  else
    RootKey := HKEY_CURRENT_USER;
  if Once then
    SKey := RunOnceKey
  else
    SKey := RunKey;
  Result := RegOpenKeyEx(RootKey, PChar(SKey), 0, KEY_WRITE, Key) = ERROR_SUCCESS;
  if Result then
  begin
    RegSetValueEx(Key, PChar(Description), 0, REG_SZ, PChar(Command), Length(Command) + 1);
    RegCloseKey(Key);
  end else
    RegCloseKey(Key);
end;

end.
